diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java b/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
index a99be0772..88ff595ac 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontFile.java
@@ -23,6 +23,15 @@ public class FontFile implements Font {
     static {
         DEFAULT_BLACKLIST.addAll(Arrays.asList('\uff0c', '\u3002', '\u3001', '\u3010', '\u3011', '\uff1b', '\u2019', '\u2018', '\u201c', '\u201d', '\uff1f', '\uff01', '\u00b7'));
     }
+    public static final int[] ALLOWED_CHARACTER_INDICES = new int[Character.MAX_VALUE];
+    static {
+        for (char c = 0; c < ALLOWED_CHARACTER_INDICES.length; c++) {
+            ALLOWED_CHARACTER_INDICES[c] = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
+        }
+        for (var c : DEFAULT_BLACKLIST) {
+            ALLOWED_CHARACTER_INDICES[c] = -1;
+        }
+    }
 
     protected static final int ITALICS_SHIFT = 1;
     protected static final int GLYPHS_PER_TEXTURE = 256;
@@ -35,6 +44,7 @@ public class FontFile implements Font {
     protected final @NotNull String glyphSizesPath;
 
     protected final @NotNull String key;
+    protected final @NotNull String @NotNull [] textureLocationTable = new String[Character.MAX_VALUE / GLYPHS_PER_TEXTURE];
 
     public FontFile(@NotNull final String key, @NotNull final String texturesFormat, @NotNull final String glyphSizesPath) {
         this.key = key;
@@ -42,6 +52,10 @@ public class FontFile implements Font {
         this.glyphSizesPath = glyphSizesPath;
         this.charWidth = new byte[Character.MAX_VALUE + 1];
         this.texHandleCache = new int[256];
+
+        for (int i = 0; i < this.textureLocationTable.length; i++) {
+            this.textureLocationTable[i] = String.format(this.textureFormat, i);
+        }
     }
 
     @Override
@@ -64,7 +78,7 @@ public class FontFile implements Font {
     public int textureForChar(final char c) {
         final int index = c / GLYPHS_PER_TEXTURE;
         if (this.texHandleCache[index] != TEXTURE_UNASSIGNED) return this.texHandleCache[index];
-        final Texture texture = Minecraft.getMinecraft().textureManager.loadTextureNoDefault(String.format(this.textureFormat, index));
+        final Texture texture = Minecraft.getMinecraft().textureManager.loadTextureNoDefault(this.textureLocationTable[index]);
         if (texture == null) {
             this.texHandleCache[index] = 0;
             return 0;
@@ -110,9 +124,8 @@ public class FontFile implements Font {
     }
 
     @Override
-    public double renderChar(final TessellatorFont tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
+    public double renderChar(final TessellatorFont tessellator, final char c, final double x, final double y, final double z) {
         if (c == ' ') return 4;
-        final int shift = italics ? ITALICS_SHIFT : 0;
 
         final int upper = this.charWidth[c] >> 4;
         final int lower = this.charWidth[c] & 0x0F;
@@ -122,13 +135,10 @@ public class FontFile implements Font {
 
         final int u = (c % 16 * 16) + fUpper;
         final int v = (c & 255) / 16 * 16;
-        final int uWidth = fLower - fUpper;
-        final int vHeight = 16;
-
-        final double width = uWidth/2d;
-        final double height = vHeight/2d;
+        final int width = fLower - fUpper;
+        final int height = 16;
 
-        tessellator.addChar(x, y, width, height, shift, u, v, uWidth, vHeight);
+        tessellator.addChar(x, y, width, height, u, v);
 
         return (fLower - fUpper)/2d + 1;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java b/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
index d7b56d405..086a3df02 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontMonospace.java
@@ -2,7 +2,6 @@ package net.minecraft.client.render.font;
 
 import net.minecraft.client.render.tessellator.TessellatorFont;
 import net.minecraft.client.render.texturepack.TexturePackList;
-import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Arrays;
@@ -22,7 +21,7 @@ public class FontMonospace extends FontFile{
 
     @Override
     public boolean canRenderChar(final char c) {
-        return !DEFAULT_BLACKLIST.contains(c) && ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c) != -1 && (c == ' ' || textureForChar(c) != 0);
+        return ALLOWED_CHARACTER_INDICES[c] != -1 && (c == ' ' || textureForChar(c) != 0);
     }
 
     @Override
@@ -31,10 +30,9 @@ public class FontMonospace extends FontFile{
     }
 
     @Override
-    public double renderChar(final TessellatorFont tessellator, final char c, final double x, final double y, final double z, final boolean italics) {
+    public double renderChar(final TessellatorFont tessellator, final char c, final double x, final double y, final double z) {
         if (c != ' ') {
-            final int shift = italics ? ITALICS_SHIFT : 0;
-            final int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
+            final int fontIndex = ALLOWED_CHARACTER_INDICES[c];
             if (fontIndex < 0) return 0;
 
             final int upper = this.charWidth[fontIndex] >> 4;
@@ -43,13 +41,10 @@ public class FontMonospace extends FontFile{
             final int fLower = (lower + 1);
             final int u = (fontIndex % 16 * 16) + fUpper;
             final int v = (fontIndex & 255) / 16 * 16;
-            final int uWidth = fLower - fUpper;
-            final int vHeight = 16;
+            final int width = fLower - fUpper;
+            final int height = 16;
 
-            final double width = uWidth/2d;
-            final double height = vHeight/2d;
-
-            tessellator.addChar(x, y, width, height, shift, u, v, uWidth, vHeight);
+            tessellator.addChar(x, y, width, height, u, v);
         }
         return MONOSPACE_WIDTH / 2d + 1;
     }
